
Declare Function TPWMandel Lib "MANDEL.DLL" (ByVal X As Double, ByVal Y As Double, ByVal i As Integer) As Integer
Declare Function TPWJulia Lib "JULIA.DLL" (ByVal X As Double, ByVal Y As Double, ByVal x1 As Double, ByVal y1 As Double, ByVal i As Integer) As Integer
Global CancelDraw As Integer
Global NOWDRAWING As Integer
Global Fractals(64) As New FractalForm

Global FractalState(64) As Integer
Global FractalXY(64, 4) As Double

Global OpenFractals As Integer
Global CurrentFractal As Integer

Global FractalColors As Integer
Global ZoomFactor As Integer
Global FractalSize As Integer
Global FractalType As Integer
Global PALETTEFILE As String
Global custsize As Integer

Global Palette(256, 3) As Integer
Type BITMAPFILEHEADER
    bfType As Integer
    bfSize As Long
    bfReserved1 As Integer
    bfReserved2 As Integer
    bfOffBits As Long
End Type

Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Type RGBTripplet
    red As Integer
    Green As Integer
    blue As Integer
End Type
Global Colors(2048) As RGBTripplet

Global XMin As Double
Global XMax As Double
Global YMin As Double
Global YMax As Double

Global XOld, YOld As Double
Global Xc As Double, Yc As Double

Function GetPalette () As Integer
Dim FNum As Integer
Dim r As String * 1
Dim g As String * 1
Dim b As String * 1
Dim a As String * 1

Dim h1 As BITMAPFILEHEADER
Dim h2 As BITMAPINFOHEADER

FNum = FreeFile
Open PALETTEFILE For Binary As FNum
Get #FNum, , h1
Get #FNum, , h2

For i = 1 To 256
    Get #FNum, , b:  Get #FNum, , g:  Get #FNum, , r
    Get #FNum, , a      ' UNUSED, but must be read (alpha channel)
    Palette(i, 1) = Asc(r):  Palette(i, 2) = Asc(g):  Palette(i, 3) = Asc(b)
Next
Close FNum

End Function

Sub Julia16 ()
Dim X As Double, Y As Double
Dim maxiter As Integer
Dim nx As Integer, ny As Integer

    nx = Fractals(CurrentFractal).Width / Screen.TwipsPerPixelX
    ny = Fractals(CurrentFractal).Height / Screen.TwipsPerPixelY
    maxiter = 256

    For iy = 0 To ny - 1
        Y = YMin + iy * (YMax - YMin) / (ny - 1)
        For ix = 0 To nx - 1
            X = XMin + ix * (XMax - XMin) / (nx - 1)
            color = TPWJulia(X, Y, Xc, Yc, maxiter)
            Fractals(CurrentFractal).PSet (ix, iy), QBColor(color Mod 16)
        Next
        Fractals(CurrentFractal).Refresh
        DoEvents
    If CancelDraw = True Then
        CancelDraw = False
        NOWDRAWING = False
        Exit Sub
    End If
    Next
    NOWDRAWING = False
    Form1!Command3D1.Caption = "DRAW FRACTAL"

End Sub

Sub Julia256 ()
Dim X As Double, Y  As Double
Dim nx As Integer, ny As Integer
Dim maxiter As Integer
            
    a% = GetPalette()
    If a% < 0 Then Exit Sub
    Fractals(CurrentFractal).Picture = LoadPicture(PALETTEFILE)
    nx = FractalSize
    ny = FractalSize
    maxiter = 256
    For iy = 0 To ny - 1
        Y = (YMin + iy * (YMax - YMin) / (ny - 1))
        For ix = 0 To nx - 1
            X = (XMin + ix * (XMax - XMin) / (nx - 1))
            color = TPWJulia(X, Y, Xc, Yc, maxiter) Mod 256
            Fractals(CurrentFractal).PSet (ix, iy), RGB(Palette(color, 1), Palette(color, 2), Palette(color, 3))
        Next
        Fractals(CurrentFractal).Refresh
        DoEvents
        If CancelDraw = True Then
            CancelDraw = False
            NOWDRAWING = False
            Exit Sub
        End If
    Next
    NOWDRAWING = False
    Form1!Command3D1.Caption = "DRAW FRACTAL"

End Sub

Sub JuliaBW ()
Dim X As Double, Y As Double
Dim maxiter As Integer
Dim nx, ny As Integer

    nx = Fractals(CurrentFractal).Width / Screen.TwipsPerPixelX
    ny = Fractals(CurrentFractal).Height / Screen.TwipsPerPixelY
    maxiter = 64

    For iy = 0 To ny - 1
        Y = YMin + iy * (YMax - YMin) / (ny - 1)
        For ix = 0 To nx - 1
            X = XMin + ix * (XMax - XMin) / (nx - 1)
            color = TPWJulia(X, Y, Xc, Yc, maxiter)
            If color = maxiter Then color = 0 Else color = 15
            Fractals(CurrentFractal).PSet (ix, iy), QBColor(color)
        Next
        Fractals(CurrentFractal).Refresh
        DoEvents
        If CancelDraw = True Then
            CancelDraw = False
            NOWDRAWING = False
            Exit Sub
        End If
    Next
    NOWDRAWING = False
    Form1!Command3D1.Caption = "DRAW FRACTAL"

End Sub

Sub JuliaTrueColor ()
Dim X As Double, Y  As Double
Dim nx As Integer, ny As Integer
Dim maxiter As Integer

    nx = FractalSize
    ny = FractalSize

    NBits = 10
    maxiter = 2 ^ NBits - 1

    For iy = 0 To ny - 1
        Y = (YMin + iy * (YMax - YMin) / (ny - 1))
        For ix = 0 To nx - 1
            X = (XMin + ix * (XMax - XMin) / (nx - 1))
            color = 1 * TPWJulia(X, Y, Xc, Yc, maxiter) Mod 2048
            If color > 2000 Then color = 2000
            Fractals(CurrentFractal).PSet (ix, iy), RGB(Colors(color).red, Colors(color).Green, Colors(color).blue)
        Next
        Fractals(CurrentFractal).Refresh
        DoEvents
        If CancelDraw = True Then
            CancelDraw = False
            NOWDRAWING = False
            Exit Sub
        End If
    Next
    NOWDRAWING = False
    Form1!Command3D1.Caption = "DRAW FRACTAL"
End Sub

Sub MakeTrueColors ()

    For i = 0 To 255
        Colors(k).red = i
        Colors(k).Green = 0
        Colors(k).blue = 0
        k = k + 1
    Next

    For i = 0 To 255
        Colors(k).red = 255
        Colors(k).Green = i
        Colors(k).blue = 0
        k = k + 1
    Next

    For i = 0 To 255
        Colors(k).red = 255
        Colors(k).Green = 255
        Colors(k).blue = i
        k = k + 1
    Next

    For i = 255 To 0 Step -1
        Colors(k).red = 255
        Colors(k).Green = i
        Colors(k).blue = 255
        k = k + 1
    Next

    For i = 255 To 0 Step -1
        Colors(k).red = i
        Colors(k).Green = 0
        Colors(k).blue = 255
        k = k + 1
    Next


    For i = 0 To 255
        Colors(k).red = 0
        Colors(k).Green = i
        Colors(k).blue = 255
        k = k + 1
    Next

    For i = 255 To 0 Step -1
        Colors(k).red = 0
        Colors(k).Green = 255
        Colors(k).blue = i
        k = k + 1
    Next


    For i = 255 To 0 Step -1
        Colors(k).red = 0
        Colors(k).Green = i
        Colors(k).blue = 0
        k = k + 1
    Next

End Sub

Sub Mandel16 ()
Dim X As Double, Y As Double
Dim maxiter As Integer
Dim nx As Integer, ny As Integer

    nx = FractalSize
    ny = FractalSize
    maxiter = 256

    For iy = 0 To ny - 1
        Y = YMin + iy * (YMax - YMin) / (ny - 1)
        For ix = 0 To nx - 1
            X = XMin + ix * (XMax - XMin) / (nx - 1)
            color = TPWMandel(X, Y, maxiter)
            Fractals(CurrentFractal).PSet (ix, iy), QBColor(color Mod 16)
        Next
        Fractals(CurrentFractal).Refresh
        DoEvents
    If CancelDraw = True Then
        CancelDraw = False
        NOWDRAWING = False
        Exit Sub
    End If
    Next
    NOWDRAWING = False
    Form1!Command3D1.Caption = "DRAW FRACTAL"

End Sub

Sub Mandel256 ()
Dim X As Double, Y As Double
Dim nx As Integer, ny As Integer
Dim maxiter As Integer

    a% = GetPalette()
    If a% < 0 Then Exit Sub
    Fractals(CurrentFractal).Picture = LoadPicture(PALETTEFILE)
    nx = FractalSize
    ny = FractalSize
    maxiter = 256
    For iy = 0 To ny - 1
        Y = (YMin + iy * (YMax - YMin) / (ny - 1))
        For ix = 0 To nx - 1
            X = (XMin + ix * (XMax - XMin) / (nx - 1))
            color = TPWMandel(X, Y, maxiter) Mod 256
            Fractals(CurrentFractal).PSet (ix, iy), RGB(Palette(color, 1), Palette(color, 2), Palette(color, 3))
        Next
        Fractals(CurrentFractal).Refresh
        DoEvents
        If CancelDraw = True Then
            CancelDraw = False
            NOWDRAWING = False
            Exit Sub
        End If
    Next
    NOWDRAWING = False
    Form1!Command3D1.Caption = "DRAW FRACTAL"
    
End Sub

Sub Mandelbw ()
Dim X As Double, Y As Double
Dim maxiter As Integer
Dim nx, ny As Integer

    nx = FractalSize
    ny = FractalSize
    maxiter = 64
    For iy = 0 To ny - 1
        Y = YMin + iy * (YMax - YMin) / (ny - 1)
        For ix = 0 To nx - 1
            X = XMin + ix * (XMax - XMin) / (nx - 1)
            color = TPWMandel(X, Y, maxiter)
            If color = maxiter Then color = 0 Else color = 15
            Fractals(CurrentFractal).PSet (ix, iy), QBColor(color)
        Next
        Fractals(CurrentFractal).Refresh
        DoEvents
        If CancelDraw = True Then
            CancelDraw = False
            NOWDRAWING = fasle
            Exit Sub
        End If
    Next
    NOWDRAWING = False
    Form1!Command3D1.Caption = "DRAW FRACTAL"

End Sub

Sub MandelTrueColor ()
Dim X As Double, Y  As Double
Dim nx As Integer, ny As Integer
Dim maxiter As Integer
Dim color As Integer

    nx = FractalSize
    ny = FractalSize
    NBits = 10
    maxiter = 2 ^ NBits - 1

    For iy = 0 To ny - 1
        Y = (YMin + iy * (YMax - YMin) / (ny - 1))
        For ix = 0 To nx - 1
            X = (XMin + ix * (XMax - XMin) / (nx - 1))
            color = 1 * TPWMandel(X, Y, maxiter) Mod 2048
            If color > 2000 Then color = 2000
            Fractals(CurrentFractal).PSet (ix, iy), RGB(Colors(color).red, Colors(color).Green, Colors(color).blue)
        Next
        Fractals(CurrentFractal).Refresh
        DoEvents
        If CancelDraw = True Then
            CancelDraw = False
            NOWDRAWING = False
            Exit Sub
        End If
    Next
    NOWDRAWING = False
    Form1!Command3D1.Caption = "DRAW FRACTAL"

End Sub

